#define USE_TI89          // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200
#define OPTIMIZE_ROM_CALLS // Use ROM Call Optimization
#define NO_EXIT_SUPPORT
#define SAVE_SCREEN

#include <tigcclib.h>

#define fatal(s) ({ST_showHelp (s); return;})

void _main (void) {
  char *fptr, *cptr;
  unsigned short plen;
  SYM_ENTRY *SymPtr = DerefSym (SymFind (SYMSTR ("grey64")));
  HANDLE h;
  if (!SymPtr) fatal (0);
  h = SymPtr->handle;
  if (HeapGetLock (h)) {
      cptr = fptr = HeapDeref (h);
      h = 0; }
  else cptr = fptr = HLock (h);
  plen = *(short*)(cptr) + 3;
  if (SymPtr->flags.bits.archived) {
      if (!(cptr = malloc (plen))) {
          if (h) HeapUnlock (h);
          fatal ("Out of memory"); }
      memcpy (cptr, fptr, plen); }
  enter_ghost_space ();
  EX_patch (cptr + 0x40002, cptr + plen + 0x3FFFE);
  ASM_call (cptr + 0x40002);
  if (h) HeapUnlock (h);
  if (cptr != fptr) free (cptr);
}
